<template>
  <v-btn
    icon="mdi-pencil-outline"
    variant="tonal"
    size="small"
    color="warning"
    class="mr-2"
    @click="isShown = true"
  />

  <v-dialog
    v-model="isShown"
    persistent
  >
    <FloatingContainer>
      <FormHeader
        icon="mdi-pencil-outline"
        headline="Изменение тарифа"
        subtitle="Заполните данные"
      />

      <section class="pt-4">
        <FormRow label="Название тарифа">
          <v-text-field
            v-model="updatedRate.name"
            :rules="[validateName]"
            :maxlength="MAX_RATE_NAME_LENGTH"
            placeholder="Название"
          />
        </FormRow>

        <FormRow label="Стоимость тарифа">
          <NumberInput
            v-model="updatedRate.profit"
            mode="price"
            :hint="profitHint"
            :min="MIN_RATE_PROFIT"
            :max="INT_SIZE"
            :step="50"
            @focus="isProfitTouched = true"
          />

          <v-scroll-y-transition>
            <v-alert
              v-if="isProfitTouched"
              icon="mdi-alert-outline"
              class="mt-3 text-yellow-600 bg-yellow-50 border-2 border-yellow-100 min-w-full w-min"
              closable
            >
              Изменение стоимости <b class="uppercase">не</b> будет применено
              к уже <b>существующим</b> бронированиям
            </v-alert>
          </v-scroll-y-transition>
        </FormRow>

        <Feedback
          :message="feedback"
          type="error"
          classes="mt-4"
        />

        <FormRow spacing="large">
          <v-btn
            block
            rounded
            size="large"
            class="text-white font-bold bg-gradient-to-r from-teal-400 to-cyan-500"
            :class="{ 'opacity-50': !isDataFilled }"
            :readonly="!isDataFilled"
            :loading="isLoading"
            @click="onUpdateClick"
          >
            Изменить
          </v-btn>
        </FormRow>

        <FormRow>
          <v-btn
            block
            rounded
            size="small"
            variant="plain"
            :ripple="false"
            class="font-bold"
            @click="isShown = false"
          >
            Отмена
          </v-btn>
        </FormRow>
      </section>
    </FloatingContainer>
  </v-dialog>
</template>

<script setup lang="ts">
import { computed, reactive, ref, watch } from 'vue';

import { createStringValidator } from '@/validators';
import { useRatesStore } from '@/stores';

import {
  MIN_RATE_NAME_LENGTH,
  MAX_RATE_NAME_LENGTH,
  MIN_RATE_PROFIT,
  INT_SIZE,
} from '@/declarations';

import FormRow from '@/components/layout/FormRow.vue';
import FormHeader from '@/components/layout/FormHeader.vue';
import FloatingContainer from '@/components/layout/FloatingContainer.vue';

import NumberInput from '@/components/content/NumberInput.vue';
import Feedback from '@/components/content/Feedback.vue';

const props = defineProps<{ data: IRate }>();
const ratesStore = useRatesStore();

const validateName = createStringValidator({
  required: true,
  length: { min: MIN_RATE_NAME_LENGTH, max: MAX_RATE_NAME_LENGTH },
});

const isShown = ref(false);
const isLoading = ref(false);
const isProfitTouched = ref(false);
const feedback = ref('');

const updatedRate = reactive({
  name: props.data.name,
  profit: parseFloat(String(props.data.profit)),
});

const profitHint = computed(() => {
  return !updatedRate.profit ? 'Этот тариф будет бесплатным' : '';
});

const isDataFilled = computed(() => {
  const isNameEntered = validateName(updatedRate.name) === true;
  const isProfitEntered = updatedRate.profit >= MIN_RATE_PROFIT;

  return isNameEntered && isProfitEntered;
});

const onUpdateClick = async () => {
  isLoading.value = true;

  const { data: { error } } = await ratesStore.editRate(props.data.id, {
    name: updatedRate.name.trim(),
    profit: updatedRate.profit,
  });

  isLoading.value = false;

  if (error) {
    feedback.value = error.message;
    return;
  }

  isShown.value = false;
};

watch(isShown, () => {
  updatedRate.name = props.data.name;
  updatedRate.profit = parseFloat(String(props.data.profit));

  isProfitTouched.value = false;
  feedback.value = '';
});
</script>